import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.border.*;

public class ControlFrame extends JFrame {

  TimeSystem ts = null;

  public void setPause( boolean p )
  {
    if( p ) PauseLabel.setText("PAUSED");
    else PauseLabel.setText("Not paused");
  }

  public void setPeriod( int p )
  {
    if     ( p == 0 ) PeriodPanel.setBackground( Color.RED );
    else if( p == 1 ) PeriodPanel.setBackground( Color.BLUE );
    else if( p == 2 ) PeriodPanel.setBackground( Color.GREEN );
    else if( p == 3 ) PeriodPanel.setBackground( Color.YELLOW );
    else PeriodPanel.setBackground( Color.BLACK );
  }

  public void setRegistered( Vector reg )
  {
    RegisteredList.setListData( reg );
  }



  public void setTime( int time )
  {
    SecondsLabel.setText( "" + time/10.0   );
  }


  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  FlowLayout flowLayout1 = new FlowLayout();
  JButton PauseButton = new JButton();
  JButton ResumeButton = new JButton();
  JPanel PeriodPanel = new JPanel();
  JLabel PauseLabel = new JLabel();
  JList RegisteredList = new JList();
  JButton KillButton = new JButton();
  TitledBorder titledBorder1;
  JPanel jPanel2 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JLabel SecondsLabel = new JLabel();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  JButton ResetButton = new JButton();

  public ControlFrame( TimeSystem timeSys ) {
    try {
      ts = timeSys;
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    titledBorder1 = new TitledBorder("");
    this.getContentPane().setLayout(borderLayout1);
    jPanel1.setLayout(flowLayout1);
    PauseButton.setText("Pause");
    PauseButton.addActionListener(new ControlFrame_PauseButton_actionAdapter(this));
    flowLayout1.setAlignment(FlowLayout.CENTER);
    ResumeButton.setText("Resume");
    ResumeButton.addActionListener(new ControlFrame_ResumeButton_actionAdapter(this));
    this.setDefaultCloseOperation(EXIT_ON_CLOSE);
    PeriodPanel.setBackground(Color.white);
    PeriodPanel.setPreferredSize(new Dimension(400, 250));
    PeriodPanel.setLayout(borderLayout3);
    PauseLabel.setFont(new java.awt.Font("Dialog", 1, 20));
    PauseLabel.setOpaque(false);
    PauseLabel.setText("Not paused");
    PauseLabel.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
    RegisteredList.setBackground(Color.white);
    RegisteredList.setBorder(BorderFactory.createLoweredBevelBorder());
    RegisteredList.setMaximumSize(new Dimension(600, 600));
    RegisteredList.setMinimumSize(new Dimension(100, 100));
    RegisteredList.setPreferredSize(new Dimension(180, 0));
    RegisteredList.setFixedCellWidth(-1);
    KillButton.setText("Unregister");
    KillButton.addActionListener(new ControlFrame_KillButton_actionAdapter(this));
    jPanel2.setLayout(borderLayout2);
    SecondsLabel.setFont(new java.awt.Font("Dialog", 0, 50));
    SecondsLabel.setText("TIME");
    borderLayout3.setHgap(0);
    jPanel3.setOpaque(false);
    jPanel4.setOpaque(false);
    ResetButton.setText("Reset");
    ResetButton.addActionListener(new ControlFrame_ResetButton_actionAdapter(this));
    this.getContentPane().add(jPanel1,  BorderLayout.SOUTH);
    jPanel1.add(PauseButton, null);
    jPanel1.add(ResumeButton, null);
    jPanel1.add(ResetButton, null);
    this.getContentPane().add(PeriodPanel,  BorderLayout.CENTER);
    this.getContentPane().add(jPanel2,  BorderLayout.EAST);
    jPanel2.add(RegisteredList,  BorderLayout.CENTER);
    jPanel2.add(KillButton,  BorderLayout.SOUTH);
    PeriodPanel.add(jPanel3, BorderLayout.NORTH);
    jPanel3.add(PauseLabel, null);
    PeriodPanel.add(jPanel4, BorderLayout.SOUTH);
    jPanel4.add(SecondsLabel, null);
  }

  void PauseButton_actionPerformed(ActionEvent e)
  {
    ts.setPause( true );
  }

  void ResumeButton_actionPerformed(ActionEvent e)
  {
    ts.setPause( false );
  }

  void KillButton_actionPerformed(ActionEvent e)
  {
    String s = (String) RegisteredList.getSelectedValue();
    ts.publisher.removeAddress( s );
  }

  void ResetButton_actionPerformed(ActionEvent e)
  {
    ts.reset();
  }
}

class ControlFrame_PauseButton_actionAdapter implements java.awt.event.ActionListener {
  ControlFrame adaptee;

  ControlFrame_PauseButton_actionAdapter(ControlFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.PauseButton_actionPerformed(e);
  }
}

class ControlFrame_ResumeButton_actionAdapter implements java.awt.event.ActionListener {
  ControlFrame adaptee;

  ControlFrame_ResumeButton_actionAdapter(ControlFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.ResumeButton_actionPerformed(e);
  }
}

class ControlFrame_KillButton_actionAdapter implements java.awt.event.ActionListener {
  ControlFrame adaptee;

  ControlFrame_KillButton_actionAdapter(ControlFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.KillButton_actionPerformed(e);
  }
}

class ControlFrame_ResetButton_actionAdapter implements java.awt.event.ActionListener {
  ControlFrame adaptee;

  ControlFrame_ResetButton_actionAdapter(ControlFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.ResetButton_actionPerformed(e);
  }
}
