import java.util.Vector;



public class TimeOutput implements TimePublisher
{
  ControlFrame    cf;
  Vector          addresses = new Vector();


  public TimeOutput( ControlFrame frame )
  {
    cf = frame;
  }

    /*  public void publishPause( boolean p, int r, int pr, int s )
	{
	System.out.println( "PAUSE: " + p );
	cf.setPause( p );
	publishString( "PAUSE:"+p );
	}
    */



  // t is time left in 10ths of second
  public void publishTick( boolean ps, int r, int p, int t )
  {
      cf.setPause( ps );

      // heartbeat every second
      if( t % 10 == 0 )
      {
        String message = "TICK:" + r + ":" + p + ":" + t/10+":";
	if( ps ) message += "1";
	else message += "0";
        System.out.println( message );
        cf.setPeriod( p );

        publishString( message );
      }

      // update screen
      cf.setTime( t );
  }


  public void publishString( String str )
  {
    for( int i=0; i<addresses.size(); i++ )
      new TimeSender( (String)(addresses.get(i)), str );
  }


  public void addAddress( String addr )
  {
    // check for repetitions
    for( int i=0; i<addresses.size(); i++ )
      if( addresses.get(i).equals( addr ) ) return;

    // update lists
    addresses.add( addr );
    cf.setRegistered( addresses );

    // output information about registration
    System.err.println("REGISTERED: " + addr );
  }

  public void removeAddress( String addr )
  {
    addresses.remove( addr );
    cf.setRegistered( addresses );
    // output
    System.err.println("UNREGISTERED: " + addr);
  }

}
