/*
TimeServer.java
The time server application
Kleptomania game

Green Team (the fabulous) October 18, 2004
 */


import java.net.*;
import java.io.*;



public class TimeServer
{
    static String waiter = "";

    public static void main( String args[] )
    {
      System.out.println("The Time Server for the incredible and so enjoyable Kleptomania Game");

      TimeSystem ts = new TimeSystem();
      ControlFrame cf = new ControlFrame( ts );

      TimeOutput to = new TimeOutput( cf );

      try
      {
	  if( args.length > 0 )
	      ts.setPeriodLen( Integer.parseInt( args[0] ) );


	  ts.setPublisher( to );
	  ts.setPause( true );
	  ts.start();
	  cf.pack();
	  cf.show();


	  while( true )
	      {
		  try
		      {
			  ServerSocket servSock = new ServerSocket(9991);
			  Socket       sock;

			  while( true )
			      {
				  sock = servSock.accept();
				  String host = sock.getInetAddress().getHostName();
				  to.addAddress( host );
				  sock.close();
			      }
		      }
		  catch( Exception e )
		      {
			  System.out.println("Failed to accept a time listener!!");
		      }
	      }
      }
      catch( NumberFormatException e )
      {
	  System.out.println("Error parsing period length");
      } 
    }
}
